const { DllReferencePlugin, DllPlugin } = require('webpack')
const join = require('path').join
const mapValues = require('lodash/mapValues')
const outputPath = join(process.cwd(), 'tmp', 'devpacks' )
const Manifests = require('./package.json').devpacks

const devpacks = mapValues(Manifests, (entry, name) => ({
  name,
  entry,
  get consumer() {
    return new DllReferencePlugin({
      context: process.cwd(),
      manifest: require(join(outputPath, `${name}.dll.json`))
    })
  },
  get dll() {
    return new DllPlugin({
      name: `${name}.dll.js`,
      path: join(outputPath, `${name}.dll.json`)
    })
  }
}))

module.exports = devpacks
