jest.dontMock('../CCNameInput');

import React from 'react';
import ReactDOM from 'react-dom';
import TestUtils from 'react-addons-test-utils';

const CCNameInput = require('../CCNameInput').default;
const callback = jest.genMockFn();

describe('CCNameInput', () => {
  let component;
  let input;

  beforeEach(() => {
    component = TestUtils.renderIntoDocument(<CCNameInput onStateUpdate={callback}/>);
    input = component.refs.ccNameInput;
  });

  it('renders properly on load', () => {
    // Should exist
    expect(input).toBeTruthy();
    // Should be empty
    expect(input.textContent).toBe('');
  });

  it('calls props.onStateUpdate to change outer state', () => {
    // Set a new value
    input.value = 'Jim Jones';

    // Change it
    TestUtils.Simulate.change(input);

    // Check it
    expect(callback).toBeCalled();
  });
});
