import Immutable from 'immutable';

import {
  UPDATE_USER_THEME,
  LOAD_USER_SETTINGS
} from 'actions/settings';

const UserSettings = new Immutable.Record({
  theme: 'dark'
});

export default function settingsReducer(settings = new UserSettings(), action) {
  switch (action.type) {
  case UPDATE_USER_THEME:
    return settings.set('theme', action.theme);
  case LOAD_USER_SETTINGS:
    return Immutable.fromJS(action.userSettings);
  default:
    return settings;
  }
}
